org.apache.solr.spelling

## Class AbstractLuceneSpellChecker

- java.lang.Object
- - org.apache.solr.spelling.SolrSpellChecker
  - - org.apache.solr.spelling.AbstractLuceneSpellChecker

- Direct Known Subclasses:
    FileBasedSpellChecker, IndexBasedSpellChecker

      public abstract class AbstractLuceneSpellChecker
      extends SolrSpellChecker

  Abstract base class for all Lucene-based spell checking implementations.

  Refer to SpellCheckComponent for more details.

  Since:
    solr 1.3

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected float` | `accuracy`
    `static String` | `ACCURACY`
    `static String` | `COMPARATOR_CLASS`
    `static int` | `DEFAULT_SUGGESTION_COUNT`
    `protected Dictionary` | `dictionary`
    `static String` | `FIELD`
    `static String` | `FREQ_COMP`
    `protected Directory` | `index`
    `static String` | `INDEX_DIR`
    `protected String` | `indexDir`
    `static String` | `LOCATION`
    `static String` | `SCORE_COMP`
    `protected StringDistance` | `sd`
    `protected String` | `sourceLocation`
    `protected SpellChecker` | `spellChecker`
    `static String` | `SPELLCHECKER_ARG_NAME`
    `static String` | `STRING_DISTANCE`

    - ### Fields inherited from class org.apache.solr.spelling.SolrSpellChecker

      `analyzer, DEFAULT_DICTIONARY_NAME, DICTIONARY_NAME, field, FIELD_TYPE, fieldTypeName, name`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractLuceneSpellChecker()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected IndexReader` | `determineReader(IndexReader reader)`
    `float` | `getAccuracy()` Get the value of `SpellingParams.SPELLCHECK_ACCURACY` if supported.
    `String` | `getField()`
    `String` | `getFieldTypeName()`
    `String` | `getIndexDir()`
    `String` | `getSourceLocation()`
    `SpellChecker` | `getSpellChecker()`
    `StringDistance` | `getStringDistance()` Get the distance implementation used by this spellchecker, or NULL if not applicable.
    `SpellingResult` | `getSuggestions(SpellingOptions options)` Get suggestions for the given query.
    `String` | `init(NamedList config, SolrCore core)`
    `protected void` | `initIndex()` Initialize the `index` variable based on the `indexDir`.
    `void` | `reload(SolrCore core, SolrIndexSearcher searcher)` Reloads the index.

    - ### Methods inherited from class org.apache.solr.spelling.SolrSpellChecker

      `build, getDictionaryName, getQueryAnalyzer, isSuggestionsMayOverlap, mergeSuggestions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SPELLCHECKER_ARG_NAME

          public static final String SPELLCHECKER_ARG_NAME

      See Also:
        Constant Field Values

    - #### LOCATION

          public static final String LOCATION

      See Also:
        Constant Field Values

    - #### INDEX_DIR

          public static final String INDEX_DIR

      See Also:
        Constant Field Values

    - #### ACCURACY

          public static final String ACCURACY

      See Also:
        Constant Field Values

    - #### STRING_DISTANCE

          public static final String STRING_DISTANCE

      See Also:
        Constant Field Values

    - #### COMPARATOR_CLASS

          public static final String COMPARATOR_CLASS

      See Also:
        Constant Field Values

    - #### SCORE_COMP

          public static final String SCORE_COMP

      See Also:
        Constant Field Values

    - #### FREQ_COMP

          public static final String FREQ_COMP

      See Also:
        Constant Field Values

    - #### spellChecker

          protected SpellChecker spellChecker

    - #### sourceLocation

          protected String sourceLocation

    - #### index

          protected Directory index

    - #### dictionary

          protected Dictionary dictionary

    - #### DEFAULT_SUGGESTION_COUNT

          public static final int DEFAULT_SUGGESTION_COUNT

      See Also:
        Constant Field Values

    - #### indexDir

          protected String indexDir

    - #### accuracy

          protected float accuracy

    - #### FIELD

          public static final String FIELD

      See Also:
        Constant Field Values

    - #### sd

          protected StringDistance sd

  - ### Constructor Detail

    - #### AbstractLuceneSpellChecker

          public AbstractLuceneSpellChecker()

  - ### Method Detail

    - #### init

          public String init(NamedList config,
                             SolrCore core)

      Overrides:
        `init` in class `SolrSpellChecker`

    - #### getSuggestions

          public SpellingResult getSuggestions(SpellingOptions options)
                                        throws IOException

      Description copied from class: `SolrSpellChecker`
      Get suggestions for the given query. Tokenizes the query using a field appropriate Analyzer. The `SpellingResult.getSuggestions()` suggestions must be ordered by best suggestion first.
      Specified by:
        `getSuggestions` in class `SolrSpellChecker`
      Parameters:
        `options` - The `SpellingOptions` to use
      Returns:
        The `SpellingResult` suggestions
      Throws:
        `IOException` - if there is an error producing suggestions

    - #### determineReader

          protected IndexReader determineReader(IndexReader reader)

    - #### reload

          public void reload(SolrCore core,
                             SolrIndexSearcher searcher)
                      throws IOException

      Description copied from class: `SolrSpellChecker`
      Reloads the index. Useful if an external process is responsible for building the spell checker.
      Specified by:
        `reload` in class `SolrSpellChecker`
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### initIndex

          protected void initIndex()
                            throws IOException

      Initialize the `index` variable based on the `indexDir`. Does not actually create the spelling index.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getAccuracy

          public float getAccuracy()

      Description copied from class: `SolrSpellChecker`
      Get the value of `SpellingParams.SPELLCHECK_ACCURACY` if supported. Otherwise throws UnsupportedOperationException.
      Overrides:
        `getAccuracy` in class `SolrSpellChecker`

    - #### getField

          public String getField()

    - #### getFieldTypeName

          public String getFieldTypeName()

    - #### getIndexDir

          public String getIndexDir()

    - #### getSourceLocation

          public String getSourceLocation()

    - #### getStringDistance

          public StringDistance getStringDistance()

      Description copied from class: `SolrSpellChecker`
      Get the distance implementation used by this spellchecker, or NULL if not applicable.
      Overrides:
        `getStringDistance` in class `SolrSpellChecker`

    - #### getSpellChecker

          public SpellChecker getSpellChecker()

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.